/*----- PROTECTED REGION ID(TuneGof2Class.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        TuneGof2Class.h
//
// description : Include for the TuneGof2 root class.
//               This class is the singleton class for
//                the TuneGof2 device class.
//               It contains all properties and methods which the
//               TuneGof2 requires only once e.g. the commands.
//
// project :     GOF2 Tune measurement
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef TuneGof2Class_H
#define TuneGof2Class_H

#include <tango/tango.h>
#include "TuneGof2.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TuneGof2Class.h


namespace TuneGof2_ns
{
/*----- PROTECTED REGION ID(TuneGof2Class::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TuneGof2Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute NumSamples class definition
class NumSamplesAttrib: public Tango::Attr
{
public:
	NumSamplesAttrib():Attr("NumSamples",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~NumSamplesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_NumSamples(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_NumSamples(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_NumSamples_allowed(ty);}
};

//	Attribute TuneMin class definition
class TuneMinAttrib: public Tango::Attr
{
public:
	TuneMinAttrib():Attr("TuneMin",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~TuneMinAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_TuneMin(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_TuneMin(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_TuneMin_allowed(ty);}
};

//	Attribute TuneMax class definition
class TuneMaxAttrib: public Tango::Attr
{
public:
	TuneMaxAttrib():Attr("TuneMax",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~TuneMaxAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_TuneMax(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_TuneMax(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_TuneMax_allowed(ty);}
};

//	Attribute TuneMinPeakThresh class definition
class TuneMinPeakThreshAttrib: public Tango::Attr
{
public:
	TuneMinPeakThreshAttrib():Attr("TuneMinPeakThresh",
			Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~TuneMinPeakThreshAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_TuneMinPeakThresh(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_TuneMinPeakThresh(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_TuneMinPeakThresh_allowed(ty);}
};

//	Attribute Tune class definition
class TuneAttrib: public Tango::Attr
{
public:
	TuneAttrib():Attr("Tune",
			Tango::DEV_FLOAT, Tango::READ) {};
	~TuneAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_Tune(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_Tune_allowed(ty);}
};

//	Attribute MaxNumBpmUsed class definition
class MaxNumBpmUsedAttrib: public Tango::Attr
{
public:
	MaxNumBpmUsedAttrib():Attr("MaxNumBpmUsed",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~MaxNumBpmUsedAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_MaxNumBpmUsed(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_MaxNumBpmUsed(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_MaxNumBpmUsed_allowed(ty);}
};

//	Attribute LPCoeff class definition
class LPCoeffAttrib: public Tango::Attr
{
public:
	LPCoeffAttrib():Attr("LPCoeff",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~LPCoeffAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_LPCoeff(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_LPCoeff(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_LPCoeff_allowed(ty);}
};

//	Attribute TuneNotch class definition
class TuneNotchAttrib: public Tango::Attr
{
public:
	TuneNotchAttrib():Attr("TuneNotch",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~TuneNotchAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_TuneNotch(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_TuneNotch(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_TuneNotch_allowed(ty);}
};

//	Attribute TuneNotchWidth class definition
class TuneNotchWidthAttrib: public Tango::Attr
{
public:
	TuneNotchWidthAttrib():Attr("TuneNotchWidth",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~TuneNotchWidthAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_TuneNotchWidth(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_TuneNotchWidth(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_TuneNotchWidth_allowed(ty);}
};

//	Attribute InhibitCycles class definition
class InhibitCyclesAttrib: public Tango::Attr
{
public:
	InhibitCyclesAttrib():Attr("InhibitCycles",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~InhibitCyclesAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_InhibitCycles(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_InhibitCycles(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_InhibitCycles_allowed(ty);}
};

//	Attribute InhibitSegmentSize class definition
class InhibitSegmentSizeAttrib: public Tango::Attr
{
public:
	InhibitSegmentSizeAttrib():Attr("InhibitSegmentSize",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~InhibitSegmentSizeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_InhibitSegmentSize(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_InhibitSegmentSize(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_InhibitSegmentSize_allowed(ty);}
};

//	Attribute DebugMinThres class definition
class DebugMinThresAttrib: public Tango::Attr
{
public:
	DebugMinThresAttrib():Attr("DebugMinThres",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~DebugMinThresAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_DebugMinThres(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_DebugMinThres(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_DebugMinThres_allowed(ty);}
};

//	Attribute DebugMaxThres class definition
class DebugMaxThresAttrib: public Tango::Attr
{
public:
	DebugMaxThresAttrib():Attr("DebugMaxThres",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~DebugMaxThresAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_DebugMaxThres(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_DebugMaxThres(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_DebugMaxThres_allowed(ty);}
};

//	Attribute HistoryBufSize class definition
class HistoryBufSizeAttrib: public Tango::Attr
{
public:
	HistoryBufSizeAttrib():Attr("HistoryBufSize",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~HistoryBufSizeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_HistoryBufSize(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_HistoryBufSize(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_HistoryBufSize_allowed(ty);}
};

//	Attribute EnableDespiking class definition
class EnableDespikingAttrib: public Tango::Attr
{
public:
	EnableDespikingAttrib():Attr("EnableDespiking",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnableDespikingAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_EnableDespiking(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_EnableDespiking(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_EnableDespiking_allowed(ty);}
};

//	Attribute DespikingFilterLen class definition
class DespikingFilterLenAttrib: public Tango::Attr
{
public:
	DespikingFilterLenAttrib():Attr("DespikingFilterLen",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~DespikingFilterLenAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_DespikingFilterLen(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_DespikingFilterLen(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_DespikingFilterLen_allowed(ty);}
};

//	Attribute Frequency class definition
class FrequencyAttrib: public Tango::Attr
{
public:
	FrequencyAttrib():Attr("Frequency",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~FrequencyAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_Frequency(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_Frequency_allowed(ty);}
};

//	Attribute FrequencySet class definition
class FrequencySetAttrib: public Tango::Attr
{
public:
	FrequencySetAttrib():Attr("FrequencySet",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~FrequencySetAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_FrequencySet(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_FrequencySet(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_FrequencySet_allowed(ty);}
};

//	Attribute InjTune class definition
class InjTuneAttrib: public Tango::Attr
{
public:
	InjTuneAttrib():Attr("InjTune",
			Tango::DEV_FLOAT, Tango::READ) {};
	~InjTuneAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_InjTune(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_InjTune_allowed(ty);}
};

//	Attribute InjPeakDetectThresh class definition
class InjPeakDetectThreshAttrib: public Tango::Attr
{
public:
	InjPeakDetectThreshAttrib():Attr("InjPeakDetectThresh",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~InjPeakDetectThreshAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_InjPeakDetectThresh(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_InjPeakDetectThresh(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_InjPeakDetectThresh_allowed(ty);}
};

//	Attribute SumThres class definition
class SumThresAttrib: public Tango::Attr
{
public:
	SumThresAttrib():Attr("SumThres",
			Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~SumThresAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_SumThres(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_SumThres(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_SumThres_allowed(ty);}
};

//	Attribute EnableInjDespiking class definition
class EnableInjDespikingAttrib: public Tango::Attr
{
public:
	EnableInjDespikingAttrib():Attr("EnableInjDespiking",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnableInjDespikingAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_EnableInjDespiking(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_EnableInjDespiking(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_EnableInjDespiking_allowed(ty);}
};

//	Attribute TunePeakAmplitude class definition
class TunePeakAmplitudeAttrib: public Tango::Attr
{
public:
	TunePeakAmplitudeAttrib():Attr("TunePeakAmplitude",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~TunePeakAmplitudeAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_TunePeakAmplitude(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_TunePeakAmplitude_allowed(ty);}
};

//	Attribute FFTRaw class definition
class FFTRawAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for FFTRaw attribute
	constexpr static long X_DATA_SIZE = 4000000;
	FFTRawAttrib():SpectrumAttr("FFTRaw",
			Tango::DEV_DOUBLE, Tango::READ, FFTRawAttrib::X_DATA_SIZE) {};
	~FFTRawAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_FFTRaw(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_FFTRaw_allowed(ty);}
};

//	Attribute FFTFilt class definition
class FFTFiltAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for FFTFilt attribute
	constexpr static long X_DATA_SIZE = 4000000;
	FFTFiltAttrib():SpectrumAttr("FFTFilt",
			Tango::DEV_DOUBLE, Tango::READ, FFTFiltAttrib::X_DATA_SIZE) {};
	~FFTFiltAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_FFTFilt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_FFTFilt_allowed(ty);}
};

//	Attribute BpmIndexList class definition
class BpmIndexListAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for BpmIndexList attribute
	constexpr static long X_DATA_SIZE = 299;
	BpmIndexListAttrib():SpectrumAttr("BpmIndexList",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, BpmIndexListAttrib::X_DATA_SIZE) {};
	~BpmIndexListAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_BpmIndexList(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TuneGof2 *>(dev))->write_BpmIndexList(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_BpmIndexList_allowed(ty);}
};

//	Attribute TuneHistory class definition
class TuneHistoryAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for TuneHistory attribute
	constexpr static long X_DATA_SIZE = 1000000;
	TuneHistoryAttrib():SpectrumAttr("TuneHistory",
			Tango::DEV_FLOAT, Tango::READ, TuneHistoryAttrib::X_DATA_SIZE) {};
	~TuneHistoryAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_TuneHistory(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_TuneHistory_allowed(ty);}
};

//	Attribute Debug class definition
class DebugAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for Debug attribute
	constexpr static long X_DATA_SIZE = 2000000;
	DebugAttrib():SpectrumAttr("Debug",
			Tango::DEV_FLOAT, Tango::READ, DebugAttrib::X_DATA_SIZE) {};
	~DebugAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TuneGof2 *>(dev))->read_Debug(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TuneGof2 *>(dev))->is_Debug_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Start class definition
class StartClass : public Tango::Command
{
public:
	StartClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	StartClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~StartClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<TuneGof2 *>(dev))->is_Start_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~StopClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<TuneGof2 *>(dev))->is_Stop_allowed(any);}
};

//	Command GetTune class definition
class GetTuneClass : public Tango::Command
{
public:
	GetTuneClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	GetTuneClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~GetTuneClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<TuneGof2 *>(dev))->is_GetTune_allowed(any);}
};


/**
 *	The TuneGof2Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  TuneGof2Class : public Tango::DeviceClass
#else
class TuneGof2Class : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(TuneGof2Class::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2Class::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static TuneGof2Class *init(const char *);
		static TuneGof2Class *instance();
		~TuneGof2Class();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		TuneGof2Class(std::string &);
		static TuneGof2Class *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	TuneGof2_H
