/*----- PROTECTED REGION ID(TuneGof2StateMachine.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        TuneGof2StateMachine.cpp
//
// description : State machine file for the TuneGof2 class
//
// project :     GOF2 Tune measurement
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include "TuneGof2.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneGof2StateMachine.cpp

//================================================================
//  States  |  Description
//================================================================
//  ON      |  
//  OFF     |  
//  FAULT   |  


namespace TuneGof2_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_NumSamples_allowed()
 * Description:  Execution allowed for NumSamples attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_NumSamples_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for NumSamples attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::NumSamplesStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::NumSamplesStateAllowed_WRITE

	//	Not any excluded states for NumSamples attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::NumSamplesStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::NumSamplesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_TuneMin_allowed()
 * Description:  Execution allowed for TuneMin attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_TuneMin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TuneMin attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneMinStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneMinStateAllowed_WRITE

	//	Not any excluded states for TuneMin attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneMinStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneMinStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_TuneMax_allowed()
 * Description:  Execution allowed for TuneMax attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_TuneMax_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TuneMax attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneMaxStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneMaxStateAllowed_WRITE

	//	Not any excluded states for TuneMax attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneMaxStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneMaxStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_TuneMinPeakThresh_allowed()
 * Description:  Execution allowed for TuneMinPeakThresh attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_TuneMinPeakThresh_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TuneMinPeakThresh attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneMinPeakThreshStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneMinPeakThreshStateAllowed_WRITE

	//	Not any excluded states for TuneMinPeakThresh attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneMinPeakThreshStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneMinPeakThreshStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_Tune_allowed()
 * Description:  Execution allowed for Tune attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_Tune_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(TuneGof2::TuneStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_MaxNumBpmUsed_allowed()
 * Description:  Execution allowed for MaxNumBpmUsed attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_MaxNumBpmUsed_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for MaxNumBpmUsed attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::MaxNumBpmUsedStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::MaxNumBpmUsedStateAllowed_WRITE

	//	Not any excluded states for MaxNumBpmUsed attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::MaxNumBpmUsedStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::MaxNumBpmUsedStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_LPCoeff_allowed()
 * Description:  Execution allowed for LPCoeff attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_LPCoeff_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for LPCoeff attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::LPCoeffStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::LPCoeffStateAllowed_WRITE

	//	Not any excluded states for LPCoeff attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::LPCoeffStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::LPCoeffStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_TuneNotch_allowed()
 * Description:  Execution allowed for TuneNotch attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_TuneNotch_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TuneNotch attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneNotchStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneNotchStateAllowed_WRITE

	//	Not any excluded states for TuneNotch attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneNotchStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneNotchStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_TuneNotchWidth_allowed()
 * Description:  Execution allowed for TuneNotchWidth attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_TuneNotchWidth_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for TuneNotchWidth attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneNotchWidthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneNotchWidthStateAllowed_WRITE

	//	Not any excluded states for TuneNotchWidth attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneNotchWidthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneNotchWidthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_InhibitCycles_allowed()
 * Description:  Execution allowed for InhibitCycles attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_InhibitCycles_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for InhibitCycles attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::InhibitCyclesStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::InhibitCyclesStateAllowed_WRITE

	//	Not any excluded states for InhibitCycles attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::InhibitCyclesStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::InhibitCyclesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_InhibitSegmentSize_allowed()
 * Description:  Execution allowed for InhibitSegmentSize attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_InhibitSegmentSize_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for InhibitSegmentSize attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::InhibitSegmentSizeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::InhibitSegmentSizeStateAllowed_WRITE

	//	Not any excluded states for InhibitSegmentSize attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::InhibitSegmentSizeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::InhibitSegmentSizeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_DebugMinThres_allowed()
 * Description:  Execution allowed for DebugMinThres attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_DebugMinThres_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DebugMinThres attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::DebugMinThresStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::DebugMinThresStateAllowed_WRITE

	//	Not any excluded states for DebugMinThres attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::DebugMinThresStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::DebugMinThresStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_DebugMaxThres_allowed()
 * Description:  Execution allowed for DebugMaxThres attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_DebugMaxThres_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DebugMaxThres attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::DebugMaxThresStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::DebugMaxThresStateAllowed_WRITE

	//	Not any excluded states for DebugMaxThres attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::DebugMaxThresStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::DebugMaxThresStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_HistoryBufSize_allowed()
 * Description:  Execution allowed for HistoryBufSize attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_HistoryBufSize_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for HistoryBufSize attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::HistoryBufSizeStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::HistoryBufSizeStateAllowed_WRITE

	//	Not any excluded states for HistoryBufSize attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::HistoryBufSizeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::HistoryBufSizeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_EnableDespiking_allowed()
 * Description:  Execution allowed for EnableDespiking attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_EnableDespiking_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableDespiking attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::EnableDespikingStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::EnableDespikingStateAllowed_WRITE

	//	Not any excluded states for EnableDespiking attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::EnableDespikingStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::EnableDespikingStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_DespikingFilterLen_allowed()
 * Description:  Execution allowed for DespikingFilterLen attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_DespikingFilterLen_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DespikingFilterLen attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::DespikingFilterLenStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::DespikingFilterLenStateAllowed_WRITE

	//	Not any excluded states for DespikingFilterLen attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::DespikingFilterLenStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::DespikingFilterLenStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_Frequency_allowed()
 * Description:  Execution allowed for Frequency attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_Frequency_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Frequency attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::FrequencyStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::FrequencyStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_FrequencySet_allowed()
 * Description:  Execution allowed for FrequencySet attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_FrequencySet_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FrequencySet attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::FrequencySetStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::FrequencySetStateAllowed_WRITE

	//	Not any excluded states for FrequencySet attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::FrequencySetStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::FrequencySetStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_InjTune_allowed()
 * Description:  Execution allowed for InjTune attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_InjTune_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for InjTune attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::InjTuneStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::InjTuneStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_InjPeakDetectThresh_allowed()
 * Description:  Execution allowed for InjPeakDetectThresh attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_InjPeakDetectThresh_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for InjPeakDetectThresh attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::InjPeakDetectThreshStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::InjPeakDetectThreshStateAllowed_WRITE

	//	Not any excluded states for InjPeakDetectThresh attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::InjPeakDetectThreshStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::InjPeakDetectThreshStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_SumThres_allowed()
 * Description:  Execution allowed for SumThres attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_SumThres_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SumThres attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::SumThresStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::SumThresStateAllowed_WRITE

	//	Not any excluded states for SumThres attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::SumThresStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::SumThresStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_EnableInjDespiking_allowed()
 * Description:  Execution allowed for EnableInjDespiking attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_EnableInjDespiking_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableInjDespiking attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::EnableInjDespikingStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::EnableInjDespikingStateAllowed_WRITE

	//	Not any excluded states for EnableInjDespiking attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::EnableInjDespikingStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::EnableInjDespikingStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_TunePeakAmplitude_allowed()
 * Description:  Execution allowed for TunePeakAmplitude attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_TunePeakAmplitude_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TunePeakAmplitude attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::TunePeakAmplitudeStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TunePeakAmplitudeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_FFTRaw_allowed()
 * Description:  Execution allowed for FFTRaw attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_FFTRaw_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FFTRaw attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::FFTRawStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::FFTRawStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_FFTFilt_allowed()
 * Description:  Execution allowed for FFTFilt attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_FFTFilt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FFTFilt attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::FFTFiltStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::FFTFiltStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_BpmIndexList_allowed()
 * Description:  Execution allowed for BpmIndexList attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_BpmIndexList_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for BpmIndexList attribute in Write access.
	/*----- PROTECTED REGION ID(TuneGof2::BpmIndexListStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::BpmIndexListStateAllowed_WRITE

	//	Not any excluded states for BpmIndexList attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::BpmIndexListStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::BpmIndexListStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_TuneHistory_allowed()
 * Description:  Execution allowed for TuneHistory attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_TuneHistory_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TuneHistory attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::TuneHistoryStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneHistoryStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_Debug_allowed()
 * Description:  Execution allowed for Debug attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_Debug_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Debug attribute in read access.
	/*----- PROTECTED REGION ID(TuneGof2::DebugStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::DebugStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_Start_allowed()
 * Description:  Execution allowed for Start attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_Start_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Start command.
	/*----- PROTECTED REGION ID(TuneGof2::StartStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::StartStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_Stop_allowed()
 * Description:  Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(TuneGof2::StopStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : TuneGof2::is_GetTune_allowed()
 * Description:  Execution allowed for GetTune attribute
 */
//--------------------------------------------------------
bool TuneGof2::is_GetTune_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetTune command.
	/*----- PROTECTED REGION ID(TuneGof2::GetTuneStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TuneGof2::GetTuneStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(TuneGof2::TuneGof2StateAllowed.AdditionalMethods) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TuneGof2::TuneGof2StateAllowed.AdditionalMethods

}	//	End of namespace
